/// <reference types="node" resolution-mode="require"/>
import { EventEmitter } from 'events';
declare type ShutDownAsyncFunction = (event?: ShutdownError) => Promise<void>;
declare class ShutdownError extends Error {
    code?: string;
    detail?: string;
}
export default class Shutdown {
    static eventEmitter: EventEmitter;
    static asyncFunctions: Record<string, ShutDownAsyncFunction>;
    static register(key: string, func: ShutDownAsyncFunction): void;
    static deregister(key: string): void;
    static emit(event: 'error', payload: {
        error: Error;
        register: string;
    }): void;
    static on(event: 'error', listener: (payload: {
        error: Error;
        register: string;
    }) => void): void;
    static off(event: string | symbol, listener: (...args: unknown[]) => void): void;
}
export {};
